<?php
/**
 * Electro Child
 *
 * @package electro-child
 */

/**
 * Include all your custom code here
 */

/**
 * Snippet to adjust Simple Range Estimated delivery based on shipping class.
 * Created at : 16 April 2018
 * Updated at : 17 April 2018
 * Xadapter Plugins : https://www.xadapter.com/shop/
 * Gist Link : https://gist.github.com/xadapter/4b36616d4ed785fb6fad8b6a5cfba84a
 */

// Adjustment on Product page.
add_action( 'woocommerce_get_availability', 'xa_estimated_delivery_product_page', 11, 2 );

function xa_estimated_delivery_product_page( $stock_arr, $item ) {

	$product_page_text_range	= "Lo tendrás entre [date_1] y [date_2] días";	// Product Page text
	$range = array(
		'ecopostural'	=> array(						// shipping class
			'min'	=> 6,									// Date Lower range
			'max'	=> 5,									// Date Higher range
		),
		'inmoclinc'	=> array(
			'min'	=> 6,
			'max'	=> 5,
		),
		'eme'	=> array(
			'min'	=> 0,
			'max'	=> 10,
		),
		'led-spa'	=> array(
			'min'	=> 0,
			'max'	=> 10,
		),
	);

	
	$product_shipping_class = $item->get_shipping_class();
	if( ! empty($range[$product_shipping_class]) ) {
		$lower_range = $range[$product_shipping_class]['min'];
		$higher_range = $range[$product_shipping_class]['max'];
		$estimated_delivery 		= get_option('wf_estimated_delivery_min_delivery_days');
		$shipping_class_dates		   = get_option('wf_estimated_delivery_shipping_class');

		foreach( $shipping_class_dates as $shipping_class_date ) {
			if( $shipping_class_date['id'] == $product_shipping_class ) {
				$estimated_delivery += (int)$shipping_class_date['min_date'];
				$product_page_text_range = str_replace('[date_1]', ( ( $estimated_delivery - $lower_range > 0 ) ? ( $estimated_delivery - $lower_range ) : 0 ) , $product_page_text_range );
				$product_page_text_range = str_replace('[date_2]', ( $estimated_delivery + $higher_range ) , $product_page_text_range);
				$stock_arr['availability'] = "$product_page_text_range";
				break;
			}
		}
	}
	return $stock_arr;
}

// Adjustment on Cart and Checkout page.
add_filter( 'xa_estimated_delivery_cart_checkout_page_html_formatted_date', 'xa_modify_cart_page_text', 10, 2 );
function xa_modify_cart_page_text( $text, $test ) {
	$display_text = "Entrega estimada";
	$adjustment = array(
		'ecopostural'	=> array(						// shipping class
			'min'	=> 6,						// Date Lower range
			'max'	=> 5,						// Date Higher range
		),
		'inmoclinc'	=> array(
			'min'	=> 6,
			'max'	=> 5,
		),
		'eme'	=> array(
			'min'	=> 0,
			'max'	=> 10,
		),
		'led-spa'	=> array(
			'min'	=> 0,
			'max'	=> 10,
		),
	);

	$text_array = explode( '<td data-title="'.$display_text.'">', $text );
	$text_array = explode( 'días</td></tr>', $text_array[1] );
	$text_array = explode( '-', $text_array[0] );

	$higher_date_check  = $text_array[1];
	foreach( WC()->cart->cart_contents as $cart_item ) {
		$shipping_class = $cart_item['data']->get_shipping_class();
		if( isset($adjustment[$shipping_class]) ) {
			if( $higher_date_check < ( (int)$text_array[1] + $adjustment[$shipping_class]['max'] ) ) {
				$shipping_class_to_consider = $shipping_class;
				$higher_date_check = (int)$text_array[1] + $adjustment[$shipping_class]['max'];
			}
		}
	}

	if( $shipping_class_to_consider && $adjustment[$shipping_class_to_consider]) {
		return '<tr class="shipping"><th> ' . $display_text . '</th><td data-title="'.$display_text.'"> ' . ( ($test - $adjustment[$shipping_class_to_consider]['min']) < 0  ? 0 : ($test - $adjustment[$shipping_class_to_consider]['min']) ) .' - '.( $test + $adjustment[$shipping_class_to_consider]['max'] ). ' days</td></tr>';
	}
	else {
		return $text;
	}
}

// Adjustment on Thank you page.
add_filter( 'xa_estimated_delivery_thank_you_page_html_formatted_date', 'xa_modify_thankyou_page_text', 10, 2 );

function xa_modify_thankyou_page_text( $text, $test ) {
	$adjustment = array(
		'ecopostural'	=> array(						// shipping class
			'min'	=> 6,						// Date Lower range
			'max'	=> 5,						// Date Higher range
		),
		'inmoclinc'	=> array(
			'min'	=> 6,
			'max'	=> 5,
		),
		'eme'	=> array(
			'min'	=> 0,
			'max'	=> 10,
		),
		'led-spa'	=> array(
			'min'	=> 0,
			'max'	=> 10,
		),
	);
	
	$text_array = explode( '-', trim( $text, 'días') );

	$higher_date_check  = $text_array[1];
	foreach( WC()->cart->cart_contents as $cart_item ) {
		$shipping_class = $cart_item['data']->get_shipping_class();
		if( isset($adjustment[$shipping_class]) ) {
			if( $higher_date_check < ( (int)$text_array[1] + $adjustment[$shipping_class]['max'] ) ) {
				$shipping_class_to_consider = $shipping_class;
				$higher_date_check = (int)$text_array[1] + $adjustment[$shipping_class]['max'];
			}
		}
	}
	if( $adjustment[$shipping_class_to_consider] ) {
		$lower_range = ( $test - $adjustment[$shipping_class_to_consider]['min'] < 0 ) ? 0 : $test - $adjustment[$shipping_class_to_consider]['min'];
		$higher_range = $test + $adjustment[$shipping_class_to_consider]['max'];

		return "$lower_range - $higher_range días ";
	}
	return $text;

}

add_filter( 'electro_accessories_query_args', 'ec_child_show_more_accessories', 20 );

function ec_child_show_more_accessories( $args ) {
	$args['posts_per_page'] = 20;
	return $args;
}

/** http://justinesgar.com/woocommerce-secret-sale/ */ 
add_filter( 'get_terms', 'get_subcategory_terms', 10, 3 );
function get_subcategory_terms( $terms, $taxonomies, $args ) {
 $new_terms = array();
 // if a product category and on the shop page
 if ( in_array( 'product_cat', $taxonomies ) && ! is_admin() ) {
 foreach ( $terms as $key => $term ) {
 if ( ! in_array( $term->slug, array( 'cestas','accesorios-carros-hospitalarios-multifuncionales','accesorios-carros-de-medicacion','accesorios-carros-con-cestas' ) ) ) {
 $new_terms[] = $term;
 }
 }
 $terms = $new_terms;
 }
 return $terms;
}
/** de aqui hasta la 241 webempresa */
function theme_strip_tags_content($text, $tags = '', $invert = false) {
 
    preg_match_all( '/<(.+?)[\s]*\/?[\s]*>/si', trim( $tags ), $tags );
    $tags = array_unique( $tags[1] );
 
    if ( is_array( $tags ) AND count( $tags ) > 0 ) {
        if ( false == $invert ) {
            return preg_replace( '@<(?!(?:'. implode( '|', $tags ) .')\b)(\w+)\b.*?>.*?</\1>@si', '', $text );
        }
        else {
            return preg_replace( '@<('. implode( '|', $tags ) .')\b.*?>.*?</\1>@si', '', $text );
        }
    }
    elseif ( false == $invert ) {
        return preg_replace( '@<(\w+)\b.*?>.*?</\1>@si', '', $text );
    }
 
    return $text;
}
 
function theme_insert_js($source) {
 
    $out = '';
 
    $fragment = new DOMDocument();
    $fragment->loadHTML( $source );
 
    $xp = new DOMXPath( $fragment );
    $result = $xp->query( '//script' );
 
    $scripts = array();
    $scripts_src = array();
    foreach ( $result as $key => $el ) {
        $src = $result->item( $key )->attributes->getNamedItem( 'src' )->value;
        if ( ! empty( $src ) ) {
            $scripts_src[] = $src;
        } else {
            $type = $result->item( $key )->attributes->getNamedItem( 'type' )->value;
            if ( empty( $type ) ) {
                $type = 'text/javascript';
            }
 
            $scripts[$type][] = $el->nodeValue;
        }
    }
 
    foreach ( $scripts as $key => $value ) {
        $out .= '<script type="'.$key.'">';
 
        foreach ( $value as $keyC => $valueC ) {
            $out .= "\n".$valueC;
        }
 
        $out .= '</script>';
    }
 
    foreach ( $scripts_src as $value ) {
        $out .= '<script src="'.$value.'"></script>';
    }
 
    return $out;
}
function add_security_headers() {
    header( 'X-Content-Type-Options: nosniff' );
    header( 'X-Frame-Options: SAMEORIGIN' );
    header( 'X-XSS-Protection: 1;mode=block' );
    header( 'Strict-Transport-Security: max-age=10886400' );
    header( 'Content-Security-Policy: default-src self' );
}
add_action( 'send_headers', 'add_security_headers' );